#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>
#include <climits>
#include <map>

using namespace std;

#define ull unsigned long long
#define ll long long

const int N = 1e6+1;
const double eps = 0.00000001;

ull fibos[93];

bool can_be_fibod(ull n, bool first = true) {
    if (n == 1) return true;

    for(int i = 2; i <= 92; i++) {
        ull k = fibos[i];
        if (n % k == 0) return can_be_fibod(n / k, false);
    }

    return false;
}

int main() {
    fibos[0] = 1;
    fibos[1] = 1;
    for(int i = 2; i <= 92; i++) {
        fibos[i] = fibos[i-1] + fibos[i-2];
        // cout << i << ") " << fibos[i] << endl;
    }


    int t;
    cin >> t;
    while(t--) {
        int n;
        cin >> n;
        if (!can_be_fibod(n)) {
            cout << 0 << endl;
            continue;
        }

        map<ull, int> factors; // how many of every n
        for(int i = 2; i <= 92; i++) {
            ull f = fibos[i];
            if (f > n && f > 3) break;
            int k = 0;
            while (n % f == 0) {
                n /= f;
                k++;
            }
            factors.insert(make_pair(f, k));
        }

        int twos = factors.find(2)->second;
        int threes = factors.find(3)->second;

        int eights_max = twos / 3;
        int onefourfours_max = min(twos / 4, threes / 2);

        ull ans = 0;
        ans = eights_max + 1;
        for(int onefourfors = 0; onefourfors < onefourfours_max; onefourfors++) {
            ans += max(0, (twos - onefourfors*4) / 3);
        }

        cout << ans << endl;
    }

    // for(int i = 2; i <= 92; i++) {
    //     if(can_be_fibod(fibos[i])) {
    //         cout << fibos[i] << endl;
    //     }
    // }
}